part of jaguar.generator.parser.route;

/// Detects interceptors on a given method or class
List<String> detectWrappers(ClassElement upper, Element element) {
  final ret = <String>[];

  for (ElementAnnotation annot in element.metadata) {
    final DartObject v = annot.computeConstantValue();
    if (isWrap.isExactlyType(v.type)) {
      v
          .getField('interceptors')
          .toListValue()
          .map((DartObject obj) => obj.toSymbolValue())
          .forEach(ret.add);
    } else if (isWrapOne.isExactlyType(v.type)) {
      ret.add(v.getField('interceptor').toSymbolValue());
    }
  }

  return ret;
}
